unit Unit1;

// --- Commentaires : par Michel BARDOU (Remerciements)

{Extrait de l'aide de Delphi :
Utilisez THintWindow pour afficher une fentre surgissante de conseil directement
dans une application. Surchargez THintWindow pour personnaliser la fentre
apparaissant automatiquement pour les contrles dont la proprit ShowHint
a la valeur True. Aprs avoir surcharg THintWindow pour crer un nouveau type
driv, affectez ce nouveau type  la variable globale HintWindowClass
au dmarrage de l'application ; ainsi le nouveau type de fentre
est utilis pour les conseils.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, shellAPi;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Image1: TImage;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Label3Click(Sender: TObject);
  private
  public
  end;

 // Surcharge de  THintWindow pour personnaliser l'info_bulle
  Ttoto = class(THintWindow)//THintWindow implmente la petite fentre
                            //surgissante qui apparat  l'excution au-dessus
                            //d'un contrle quand la proprit ShowHint du contrle a la valeur True.
                            // bref ca implmente une info-bulle.
  private
    FRegion: THandle;
  public
    procedure ActivateHint(ARect: TRect; const AHint: string); override;
    procedure Paint; override;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate;
begin
  Hint := 'Bulle d''aide personnalise !';
  //  affectation du nouveau type Ttoto  la variable globale HintWindowClass
  //au dmarrage de l'application ; ainsi le nouveau type d'info-bulle Ttoto
  //est utilis pour les conseils.
  HintWindowClass := Ttoto;
  Application.HintColor := $00FF8000;
  ShowHint := true;
end;

procedure Ttoto.ActivateHint;
// cette procdure tant appel juste avant l'activation de la fentre info-bulle
// on en profite pour modifier sa taille.
begin
  //On va modifier ARect (le rectangle o s'affichera notre info-bulle
  // On modifie la coordonne de droite de ce rectangle pour qu'il ait
  // la taille souhaite (ici la taille d'un certain texte)
  with ARect do
       Right := Right + Canvas.TextWidth('ABCD');
      //BoundsRect Reprsente le rectangle de dlimitation du contrle
      //(ici Ttoto),
       BoundsRect := ARect;
  with BoundsRect do
       FRegion := CreateRoundRectRgn(0,-15{c}, Width*2,Height*2, Width, Height);
       if FRegion <> 0 then
          SetWindowRgn(Handle, FRegion, True);
  inherited ActivateHint(ARect, AHint);
end;

procedure Ttoto.Paint;
// Ttoto.Paint est appel  chaque fois que l'application a besoin de dessiner
// une info-bulle puisque Ttoto est maintenant la classe qui correspond
//  l'info-bulle
var  R: TRect;
begin
  R := ClientRect;
  Canvas.Font.Color := clwhite;
  Canvas.Font.Style := [fsBold];
  // le caption d'un THintWindow est automatiquement rempli avec la valeur de
  // la proprit Hint du control qui a dclench l'affichage de l'info-bulle
  DrawText(Canvas.Handle, PChar(Caption), Length(Caption), R, DT_NOPREFIX or DT_WORDBREAK or DT_CENTER or DT_VCENTER);
end;

procedure TForm1.Label3Click(Sender: TObject);
begin
 ShellExecute(0, 'Open', 'http://dev-zone.com/faq/delphi/fqdph_index.php', nil, nil, SW_SHOWNORMAL);
end;

end.
